<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: Commander Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classCommander.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classCommander-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Commander Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="Commander_8hpp_source.html">Commander.hpp</a>&quot;</code></p>
<div class="dynheader">
Inheritance diagram for Commander:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classCommander.png" usemap="#Commander_map" alt=""/>
  <map id="Commander_map" name="Commander_map">
<area href="classButtonsCommanderClass.html" alt="ButtonsCommanderClass" shape="rect" coords="0,56,151,80"/>
<area href="classCANCommanderClass.html" alt="CANCommanderClass" shape="rect" coords="161,56,312,80"/>
<area href="classDccCommanderClass.html" alt="DccCommanderClass" shape="rect" coords="322,56,473,80"/>
<area href="classI2CCommanderClass.html" alt="I2CCommanderClass" shape="rect" coords="483,56,634,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ac3fc4568a88c91cb4ab97de9f77698a9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCommander.html#ac3fc4568a88c91cb4ab97de9f77698a9">Commander</a> ()</td></tr>
<tr class="separator:ac3fc4568a88c91cb4ab97de9f77698a9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade3914b5c62cd08a4e97050bc5314734"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCommander.html#ade3914b5c62cd08a4e97050bc5314734">PriorityLoop</a> ()</td></tr>
<tr class="separator:ade3914b5c62cd08a4e97050bc5314734"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a07837869d9f0d6950cd8c40dacc7e05f"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCommander.html#a07837869d9f0d6950cd8c40dacc7e05f">beforeFirstLoop</a> ()</td></tr>
<tr class="separator:a07837869d9f0d6950cd8c40dacc7e05f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad071adf2b8c272269394c2c66bf46f00"><td class="memItemLeft" align="right" valign="top">virtual unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCommander.html#ad071adf2b8c272269394c2c66bf46f00">loop</a> ()</td></tr>
<tr class="separator:ad071adf2b8c272269394c2c66bf46f00"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:add75d0185fe8f8fc0c9a92a02f3663c8"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCommander.html#add75d0185fe8f8fc0c9a92a02f3663c8">CommanderPriorityLoops</a> ()</td></tr>
<tr class="separator:add75d0185fe8f8fc0c9a92a02f3663c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa11f6874d5b0faad6867415fe20ee96d"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCommander.html#aa11f6874d5b0faad6867415fe20ee96d">BeforeFirstLoops</a> ()</td></tr>
<tr class="separator:aa11f6874d5b0faad6867415fe20ee96d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a10c7c5ee5db3da8acf2b7c8bfd5e3067"><td class="memItemLeft" align="right" valign="top">static unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classCommander.html#a10c7c5ee5db3da8acf2b7c8bfd5e3067">loops</a> ()</td></tr>
<tr class="separator:a10c7c5ee5db3da8acf2b7c8bfd5e3067"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This is the base class for all the commanders.</p>
<p>DO NOT INSTANCIATE THIS CLASS !</p>
<p>A commander is a class with a loop function which is able to raise events for a source. Each commander is an item into a linked list of commanders. There is one and only one Commander of a given type during a library session. </p>

<p class="definition">Definition at line <a class="el" href="Commander_8hpp_source.html#l00023">23</a> of file <a class="el" href="Commander_8hpp_source.html">Commander.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ac3fc4568a88c91cb4ab97de9f77698a9"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Commander::Commander </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="Commander_8hpp_source.html#l00031">31</a> of file <a class="el" href="Commander_8hpp_source.html">Commander.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a07837869d9f0d6950cd8c40dacc7e05f"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Commander::beforeFirstLoop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>This function will be called after sketch Setup(), but before the first call to <a class="el" href="classCommander.html#ad071adf2b8c272269394c2c66bf46f00">loop()</a>. It will be called only one time. </p>

<p>Reimplemented in <a class="el" href="classButtonsCommanderClass.html#abc33c28391bc3bedc44a157f10624ca0">ButtonsCommanderClass</a>.</p>

<p class="definition">Definition at line <a class="el" href="Commander_8hpp_source.html#l00040">40</a> of file <a class="el" href="Commander_8hpp_source.html">Commander.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="aa11f6874d5b0faad6867415fe20ee96d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Commander::BeforeFirstLoops </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>This function will call all BeforeFirstLoop() in sequence. </p>

<p class="definition">Definition at line <a class="el" href="Commander_8cpp_source.html#l00033">33</a> of file <a class="el" href="Commander_8cpp_source.html">Commander.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="add75d0185fe8f8fc0c9a92a02f3663c8"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Commander::CommanderPriorityLoops </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>This function will call all <a class="el" href="classCommander.html#ade3914b5c62cd08a4e97050bc5314734">PriorityLoop()</a> in sequence. </p>

<p class="definition">Definition at line <a class="el" href="Commander_8cpp_source.html#l00044">44</a> of file <a class="el" href="Commander_8cpp_source.html">Commander.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ad071adf2b8c272269394c2c66bf46f00"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned long Commander::loop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Main loop of this commander. </p><dl class="section return"><dt>Returns</dt><dd><a class="el" href="structEvent.html">Event</a> Id if an event has been raised, or <a class="el" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a> if not. </dd></dl>

<p>Reimplemented in <a class="el" href="classDccCommanderClass.html#a0c97ea34dfdf4c13de53a58937df5580">DccCommanderClass</a>, <a class="el" href="classCANCommanderClass.html#ac55b4d106afa8c09764931e287eb7c42">CANCommanderClass</a>, <a class="el" href="classButtonsCommanderClass.html#acda3beac661dcf22d2593c76fde1a634">ButtonsCommanderClass</a>, and <a class="el" href="classI2CCommanderClass.html#a11fda5e10b4caf40275fea5854018808">I2CCommanderClass</a>.</p>

<p class="definition">Definition at line <a class="el" href="Commander_8hpp_source.html#l00044">44</a> of file <a class="el" href="Commander_8hpp_source.html">Commander.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a10c7c5ee5db3da8acf2b7c8bfd5e3067"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long Commander::loops </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>This function will call all <a class="el" href="classCommander.html#ad071adf2b8c272269394c2c66bf46f00">loop()</a> in sequence. </p><dl class="section return"><dt>Returns</dt><dd><a class="el" href="structEvent.html">Event</a> Id if an event has been raised, or <a class="el" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a> if not. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Commander_8cpp_source.html#l00055">55</a> of file <a class="el" href="Commander_8cpp_source.html">Commander.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ade3914b5c62cd08a4e97050bc5314734"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Commander::PriorityLoop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Priority loop function. A commander can need more call to its loop than normal. The priority loop functions of all the commanders will be called before any commander loop. </p>

<p>Reimplemented in <a class="el" href="classDccCommanderClass.html#a688f192c9f26dfe824a86b6aa00152df">DccCommanderClass</a>.</p>

<p class="definition">Definition at line <a class="el" href="Commander_8hpp_source.html#l00037">37</a> of file <a class="el" href="Commander_8hpp_source.html">Commander.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="Commander_8hpp_source.html">Commander.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="Commander_8cpp_source.html">Commander.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classCommander.html">Commander</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
